using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Windows.Forms;
using System.Drawing;
using MinorShift.Emuera.Sub;

namespace MinorShift.Emuera
{
	public sealed class StrIgnoreCaseComparer : IComparer<string>
	{
		public int Compare(string x, string y)
		{
			return string.Compare(x, y, StringComparison.OrdinalIgnoreCase);
		}
	}

	/// <summary>
	/// vOŜŎgplWindow쐬Oɐݒ肵ĈȌύXȂ
	/// (Ƃ\肾͈Ⴄ)
	/// </summary>
	internal sealed class Config
	{
		readonly static string configPath = Program.ExeDir + "emuera.config";
        readonly static string macroPath = Program.ExeDir + "macro.txt";

		static Config() { }
		private static Config instance = new Config();
		public static Config Instance { get { return instance; } }
		public readonly static Encoding Encode = Encoding.GetEncoding("SHIFT-JIS");

		private Config() { setDefault(); }

		//Kɑ傫ڂ̔zĂB
		private AConfigItem[] configArray = new AConfigItem[55];
		private AConfigItem[] replaceArray = new AConfigItem[50];
        private AConfigItem[] macroArray = new AConfigItem[12];

		private void setDefault()
		{
			int i = 0;
			configArray[i++] = new ConfigItem<bool>(ConfigCode.IgnoreCase, "啶̈Ⴂ𖳎", true);
			configArray[i++] = new ConfigItem<bool>(ConfigCode.UseRenameFile, "_Rename.csv𗘗p", false);
			configArray[i++] = new ConfigItem<bool>(ConfigCode.UseReplaceFile, "_Replace.csv𗘗p", true);
			configArray[i++] = new ConfigItem<bool>(ConfigCode.UseMouse, "}EXgp", true);
			configArray[i++] = new ConfigItem<bool>(ConfigCode.UseMenu, "j[gp", true);
			configArray[i++] = new ConfigItem<bool>(ConfigCode.UseDebugCommand, "fobOR}hgp", false);
			configArray[i++] = new ConfigItem<bool>(ConfigCode.AllowMultipleInstances, "dN", true);
			configArray[i++] = new ConfigItem<bool>(ConfigCode.AutoSave, "I[gZ[usȂ", true);
            configArray[i++] = new ConfigItem<bool>(ConfigCode.UseKeyMacro, "L[{[h}Ngp", true);
			configArray[i++] = new ConfigItem<bool>(ConfigCode.SizableWindow, "EBhE̍ςɂ", true);
			configArray[i++] = new ConfigItem<TextDrawingMode>(ConfigCode.TextDrawingMode, "`C^[tF[X", TextDrawingMode.GRAPHICS);
			configArray[i++] = new ConfigItem<bool>(ConfigCode.UseImageBuffer, "C[Wobt@gp", true);
			configArray[i++] = new ConfigItem<int>(ConfigCode.WindowX, "EBhE", 760);
			configArray[i++] = new ConfigItem<int>(ConfigCode.WindowY, "EBhE", 480);
			configArray[i++] = new ConfigItem<int>(ConfigCode.WindowPosX, "EBhEʒuX", 0);
			configArray[i++] = new ConfigItem<int>(ConfigCode.WindowPosY, "EBhEʒuY", 0);
			configArray[i++] = new ConfigItem<bool>(ConfigCode.SetWindowPos, "ÑEBhEʒuw肷", false);
            configArray[i++] = new ConfigItem<bool>(ConfigCode.WindowMaximixed, "NɃEBhEő剻", false);
			configArray[i++] = new ConfigItem<int>(ConfigCode.MaxLog, "O̍s", 5000);
			configArray[i++] = new ConfigItem<int>(ConfigCode.PrintCPerLine, "PRINTCׂ鐔", 3);
			configArray[i++] = new ConfigItem<int>(ConfigCode.PrintCLength, "PRINTC̕", 25);
			configArray[i++] = new ConfigItem<string>(ConfigCode.FontName, "tHg", "lr SVbN");
			configArray[i++] = new ConfigItem<int>(ConfigCode.FontSize, "tHgTCY", 18);
			configArray[i++] = new ConfigItem<int>(ConfigCode.LineHeight, "s̍", 19);
			configArray[i++] = new ConfigItem<Color>(ConfigCode.ForeColor, "F", Color.FromArgb(192, 192, 192));//LIGHTGRAY
			configArray[i++] = new ConfigItem<Color>(ConfigCode.BackColor, "wiF", Color.FromArgb(0, 0, 0));//BLACK
			configArray[i++] = new ConfigItem<Color>(ConfigCode.FocusColor, "I𒆕F", Color.FromArgb(255, 255, 0));//YELLOW
			configArray[i++] = new ConfigItem<Color>(ConfigCode.LogColor, "𕶎F", Color.FromArgb(192, 192, 192));//LIGHTGRAY//Color.FromArgb(128, 128, 128);//GRAY
			configArray[i++] = new ConfigItem<int>(ConfigCode.FPS, "t[b", 5);
			configArray[i++] = new ConfigItem<int>(ConfigCode.SkipFrame, "őXLbvt[", 3);
            configArray[i++] = new ConfigItem<int>(ConfigCode.ScrollHeight, "XN[s", 1);
            configArray[i++] = new ConfigItem<int>(ConfigCode.InfiniteLoopAlertTime, "[vx܂ł̃~b", 5000);
			configArray[i++] = new ConfigItem<int>(ConfigCode.DisplayWarningLevel, "\Œxx", 1);
			configArray[i++] = new ConfigItem<bool>(ConfigCode.DisplayReport, "[hɃ|[g\", false);
			configArray[i++] = new ConfigItem<ReduceArgumentOnLoadFlag>(ConfigCode.ReduceArgumentOnLoad, "[hɈ͂", ReduceArgumentOnLoadFlag.NO);
			configArray[i++] = new ConfigItem<bool>(ConfigCode.ReduceFormattedStringOnLoad, "[hFORM͂", true);
			configArray[i++] = new ConfigItem<bool>(ConfigCode.IgnoreUncalledFunction, "ĂяoȂ֐𖳎", true);
			configArray[i++] = new ConfigItem<DisplayWarningFlag>(ConfigCode.FunctionNotFoundWarning, "֐Ȃẍ", DisplayWarningFlag.IGNORE);
			configArray[i++] = new ConfigItem<DisplayWarningFlag>(ConfigCode.FunctionNotCalledWarning, "֐ĂяoȂẍ", DisplayWarningFlag.IGNORE);
			configArray[i++] = new ConfigItem<List<string>>(ConfigCode.IgnoreWarningFiles, "w肵t@Čx𖳎", new List<string>());
			configArray[i++] = new ConfigItem<bool>(ConfigCode.ChangeMasterNameIfDebug, "fobOR}hgpMASTER̖OύX", true);
			configArray[i++] = new ConfigItem<bool>(ConfigCode.ButtonWrap, "{^̓rōs܂肩Ȃ", false);
			configArray[i++] = new ConfigItem<bool>(ConfigCode.SearchSubdirectory, "TufBNg", false);
			configArray[i++] = new ConfigItem<bool>(ConfigCode.SortWithFilename, "ǂݍݏt@CɃ\[g", false);
            configArray[i++] = new ConfigItem<long>(ConfigCode.LastKey, "ŏIXVR[h", 0);
            configArray[i++] = new ConfigItem<int>(ConfigCode.SaveDataNos, "\Z[uf[^", 20);
			configArray[i++] = new ConfigItem<bool>(ConfigCode.WarnBackCompatibility, "eramaker݊Ɋւx\", true);
			configArray[i++] = new ConfigItem<bool>(ConfigCode.AllowFunctionOverloading, "VXe֐̏㏑", true);
			configArray[i++] = new ConfigItem<bool>(ConfigCode.WarnFunctionOverloading, "VXe֐㏑ꂽƂx\", true);
            configArray[i++] = new ConfigItem<string>(ConfigCode.TextEditor, "֘AÂeLXgGfB^", "notepad");
            configArray[i++] = new ConfigItem<string>(ConfigCode.EditorArgument, "GfB^ɓnsw", "");
            configArray[i++] = new ConfigItem<bool>(ConfigCode.WarnNormalFunctionOverloading, "̔Cxg֐`ꂽƂx", false);
			
			i = 0;
			replaceArray[i++] = new ConfigItem<string>(ConfigCode.MoneyLabel, "̒P", "$");
			replaceArray[i++] = new ConfigItem<bool>(ConfigCode.MoneyFirst, "Pʂ̈ʒu", true);
			replaceArray[i++] = new ConfigItem<string>(ConfigCode.LoadLabel, "Nȗ\", "Now Loading...");
			replaceArray[i++] = new ConfigItem<int>(ConfigCode.MaxShopItem, "̔ACe", 100);
			replaceArray[i++] = new ConfigItem<string>(ConfigCode.DrawLineString, "DRAWLINE", "-");
			replaceArray[i++] = new ConfigItem<char>(ConfigCode.BarChar1, "BAR1", '*');
			replaceArray[i++] = new ConfigItem<char>(ConfigCode.BarChar2, "BAR2", '.');
			replaceArray[i++] = new ConfigItem<string>(ConfigCode.TitleMenuString0, "VXej[0", "ŏ͂߂");
			replaceArray[i++] = new ConfigItem<string>(ConfigCode.TitleMenuString1, "VXej[1", "[hĂ͂߂");
            replaceArray[i++] = new ConfigItem<int>(ConfigCode.ComAbleDefault, "COM_ABLEl", 1);
            replaceArray[i++] = new ConfigItem<List<Int64>>(ConfigCode.StainDefault, "̏l", new List<Int64>(new Int64[]{0,0,2,1,8}));
            replaceArray[i++] = new ConfigItem<string>(ConfigCode.TimeupLabel, "Ԑ؂\", "Ԑ؂");
            replaceArray[i++] = new ConfigItem<List<Int64>>(ConfigCode.ExpLvDef, "EXPLV̏l", new List<long>(new Int64[]{0, 1, 4, 20, 50, 200}));
            replaceArray[i++] = new ConfigItem<List<Int64>>(ConfigCode.PalamLvDef, "PALAMLV̏l", new List<long>(new Int64[] { 0, 100, 500, 3000, 10000, 30000, 60000, 100000, 150000, 250000}));
            replaceArray[i++] = new ConfigItem<Int64>(ConfigCode.pbandDef, "PBAND̏l", 4);

            i = 0;
            macroArray[i++] = new ConfigItem<string>(ConfigCode.MacroF1, "}NL[F1", "");
            macroArray[i++] = new ConfigItem<string>(ConfigCode.MacroF2, "}NL[F2", "");
            macroArray[i++] = new ConfigItem<string>(ConfigCode.MacroF3, "}NL[F3", "");
            macroArray[i++] = new ConfigItem<string>(ConfigCode.MacroF4, "}NL[F4", "");
            macroArray[i++] = new ConfigItem<string>(ConfigCode.MacroF5, "}NL[F5", "");
            macroArray[i++] = new ConfigItem<string>(ConfigCode.MacroF6, "}NL[F6", "");
            macroArray[i++] = new ConfigItem<string>(ConfigCode.MacroF7, "}NL[F7", "");
            macroArray[i++] = new ConfigItem<string>(ConfigCode.MacroF8, "}NL[F8", "");
            macroArray[i++] = new ConfigItem<string>(ConfigCode.MacroF9, "}NL[F9", "");
            macroArray[i++] = new ConfigItem<string>(ConfigCode.MacroF10, "}NL[F10", "");
            macroArray[i++] = new ConfigItem<string>(ConfigCode.MacroF11, "}NL[F11", "");
            macroArray[i++] = new ConfigItem<string>(ConfigCode.MacroF12, "}NL[F12", "");
        }
		public Config Copy()
		{
			Config config = new Config();
			//for(int i = 0; i< configArray.Length;i++)
			//    config.configArray[i] = AConfigItem.Copy(this.configArray[i]);
			//for(int i = 0; i< replaceArray.Length;i++)
			//    config.replaceArray[i] = AConfigItem.Copy(this.replaceArray[i]);
			for (int i = 0; i < configArray.Length; i++)
				if ((this.configArray[i] != null) && (config.configArray[i] != null))
					this.configArray[i].CopyTo(config.configArray[i]);
			for (int i = 0; i < replaceArray.Length; i++)
				if ((this.replaceArray[i] != null) && (config.replaceArray[i] != null))
					this.replaceArray[i].CopyTo(config.replaceArray[i]);
            for (int i = 0; i < macroArray.Length; i++)
                if ((this.macroArray[i] != null) && (config.macroArray[i] != null))
                    this.macroArray[i].CopyTo(config.macroArray[i]);
			return config;
		}

		public T GetConfigValue<T>(ConfigCode code)
		{
			AConfigItem item = GetItem(code);
			if ((item != null) && (item is ConfigItem<T>))
				return ((ConfigItem<T>)item).Value;
			throw new ExeEE("GetConfigValueCode܂͌^sK");
		}

#region getitem
		public AConfigItem GetItem(ConfigCode code)
		{
			AConfigItem item = GetConfigItem(code);
            if (item == null)
            {
                item = GetReplaceItem(code);
                if (item == null)
                    return GetMacroItem(code);
            }
			return item;
		}
		public AConfigItem GetItem(string key)
		{
			AConfigItem item = GetConfigItem(key);
			if (item == null)
				return GetReplaceItem(key);
			return item;
		}

		public AConfigItem GetConfigItem(ConfigCode code)
		{
			foreach (AConfigItem item in configArray)
			{
				if (item == null)
					continue;
				if (item.Code == code)
					return item;
			}
			return null;
		}
		public AConfigItem GetConfigItem(string key)
		{
			foreach (AConfigItem item in configArray)
			{
				if (item == null)
					continue;
				if (item.Name == key)
					return item;
				if (item.Text == key)
					return item;
			}
			return null;
		}

		public AConfigItem GetReplaceItem(ConfigCode code)
		{
			foreach (AConfigItem item in replaceArray)
			{
				if (item == null)
					continue;
				if (item.Code == code)
					return item;
			}
			return null;
		}
		public AConfigItem GetReplaceItem(string key)
		{
			foreach (AConfigItem item in replaceArray)
			{
				if (item == null)
					continue;
				if (item.Name == key)
					return item;
				if (item.Text == key)
					return item;
			}
			return null;
		}
		public AConfigItem GetMacroItem(ConfigCode code)
		{
			foreach (AConfigItem item in macroArray)
			{
				if (item == null)
					continue;
				if (item.Code == code)
					return item;
			}
			return null;
		}
		public AConfigItem GetMacroItem(string key)
		{
			foreach (AConfigItem item in macroArray)
			{
				if (item == null)
					continue;
				if (item.Name == key)
					return item;
				if (item.Text == key)
					return item;
			}
			return null;
		}
#endregion

#region vpeB

		public bool IgnoreCase { get { return GetConfigValue<bool>(ConfigCode.IgnoreCase); } }
		public bool UseRenameFile { get { return GetConfigValue<bool>(ConfigCode.UseRenameFile); } }
		public bool UseReplaceFile { get { return GetConfigValue<bool>(ConfigCode.UseReplaceFile); } }
		public bool UseMouse { get { return GetConfigValue<bool>(ConfigCode.UseMouse); } }
		public bool UseMenu { get { return GetConfigValue<bool>(ConfigCode.UseMenu); } }
		public bool UseDebugCommand { get { return GetConfigValue<bool>(ConfigCode.UseDebugCommand); } }
		public bool AllowMultipleInstances { get { return GetConfigValue<bool>(ConfigCode.AllowMultipleInstances); } }
		public bool AutoSave { get { return GetConfigValue<bool>(ConfigCode.AutoSave); } }
        public bool UseKeyMacro { get { return GetConfigValue<bool>(ConfigCode.UseKeyMacro); } }
		public bool SizableWindow { get { return GetConfigValue<bool>(ConfigCode.SizableWindow); } }
		public bool UseImageBuffer { get { return GetConfigValue<bool>(ConfigCode.UseImageBuffer); } }
		public TextDrawingMode TextDrawingMode { get { return GetConfigValue<TextDrawingMode>(ConfigCode.TextDrawingMode); } }
		public int WindowX { get { return GetConfigValue<int>(ConfigCode.WindowX); } }
		public int WindowY { get { return GetConfigValue<int>(ConfigCode.WindowY); } }
		public int WindowPosX { get { return GetConfigValue<int>(ConfigCode.WindowPosX); } }
		public int WindowPosY { get { return GetConfigValue<int>(ConfigCode.WindowPosY); } }
		public bool SetWindowPos { get { return GetConfigValue<bool>(ConfigCode.SetWindowPos); } }
		public int MaxLog { get { return GetConfigValue<int>(ConfigCode.MaxLog); } }
		public int PrintCPerLine { get { return GetConfigValue<int>(ConfigCode.PrintCPerLine); } }
		public int PrintCLength { get { return GetConfigValue<int>(ConfigCode.PrintCLength); } }
		public Color ForeColor { get { return GetConfigValue<Color>(ConfigCode.ForeColor); } }
		public Color BackColor { get { return GetConfigValue<Color>(ConfigCode.BackColor); } }
		public Color FocusColor { get { return GetConfigValue<Color>(ConfigCode.FocusColor); } }
		public Color LogColor { get { return GetConfigValue<Color>(ConfigCode.LogColor); } }
		public int Fontsize { get { return GetConfigValue<int>(ConfigCode.FontSize); } }
		public string Fontname { get { return GetConfigValue<string>(ConfigCode.FontName); } }
		public int LineHeight { get { return GetConfigValue<int>(ConfigCode.LineHeight); } }
		public int FPS { get { return GetConfigValue<int>(ConfigCode.FPS); } }
		public int SkipFrame { get { return GetConfigValue<int>(ConfigCode.SkipFrame); } }
        public int ScrollHeight { get { return GetConfigValue<int>(ConfigCode.ScrollHeight); } }
        public int InfiniteLoopAlertTime { get { return GetConfigValue<int>(ConfigCode.InfiniteLoopAlertTime); } }
        public int SaveDataNos { get { return GetConfigValue<int>(ConfigCode.SaveDataNos); } }
        public bool WarnBackCompatibility { get { return GetConfigValue<bool>(ConfigCode.WarnBackCompatibility); } }
        public bool WindowMaximixed { get { return GetConfigValue<bool>(ConfigCode.WindowMaximixed); } }
        public bool WarnNormalFunctionOverloading { get { return GetConfigValue<bool>(ConfigCode.WarnNormalFunctionOverloading); } }
        
        public bool AllowFunctionOverloading { get { return GetConfigValue<bool>(ConfigCode.AllowFunctionOverloading); } }
        public bool WarnFunctionOverloading { get {
			if (!AllowFunctionOverloading) return true;
			return GetConfigValue<bool>(ConfigCode.WarnFunctionOverloading); 
		} }
		
		public int DisplayWarningLevel { get { return GetConfigValue<int>(ConfigCode.DisplayWarningLevel); } }
		public bool DisplayReport { get { return GetConfigValue<bool>(ConfigCode.DisplayReport); } }
		public ReduceArgumentOnLoadFlag ReduceArgumentOnLoad { get { return GetConfigValue<ReduceArgumentOnLoadFlag>(ConfigCode.ReduceArgumentOnLoad); } }
		public bool ReduceFormattedStringOnLoad { get { return GetConfigValue<bool>(ConfigCode.ReduceFormattedStringOnLoad); } }
		public bool IgnoreUncalledFunction { get { return GetConfigValue<bool>(ConfigCode.IgnoreUncalledFunction); } }
		public DisplayWarningFlag FunctionNotFoundWarning { get { return GetConfigValue<DisplayWarningFlag>(ConfigCode.FunctionNotFoundWarning); } }
		public DisplayWarningFlag FunctionNotCalledWarning { get { return GetConfigValue<DisplayWarningFlag>(ConfigCode.FunctionNotCalledWarning); } }
		public List<string> IgnoreWarningFiles { get { return GetConfigValue<List<string>>(ConfigCode.IgnoreWarningFiles); } }

		public bool ChangeMasterNameIfDebug { get { return GetConfigValue<bool>(ConfigCode.ChangeMasterNameIfDebug); } }
		public long LastKey { get { return GetConfigValue<long>(ConfigCode.LastKey); } }
		public bool ButtonWrap { get { return GetConfigValue<bool>(ConfigCode.ButtonWrap); } }

        public string TextEditor { get { return GetConfigValue<string>(ConfigCode.TextEditor); } }
        public string EditorArg { get { return GetConfigValue<string>(ConfigCode.EditorArgument); } }

		public string MoneyLabel { get { return GetConfigValue<string>(ConfigCode.MoneyLabel); } }
		public bool MoneyFirst { get { return GetConfigValue<bool>(ConfigCode.MoneyFirst); } }
		public string LoadLabel { get { return GetConfigValue<string>(ConfigCode.LoadLabel); } }
		public int MaxShopItem { get { return GetConfigValue<int>(ConfigCode.MaxShopItem); } }
		public string DrawLineString { get { return GetConfigValue<string>(ConfigCode.DrawLineString); } }
		public char BarChar1 { get { return GetConfigValue<char>(ConfigCode.BarChar1); } }
		public char BarChar2 { get { return GetConfigValue<char>(ConfigCode.BarChar2); } }
		public string TitleMenuString0 { get { return GetConfigValue<string>(ConfigCode.TitleMenuString0); } }
		public string TitleMenuString1 { get { return GetConfigValue<string>(ConfigCode.TitleMenuString1); } }
		public int ComAbleDefault { get { return GetConfigValue<int>(ConfigCode.ComAbleDefault); } }
        public List<Int64> StainDefault { get { return GetConfigValue<List<Int64>>(ConfigCode.StainDefault); } }
        public string TimeupLabel { get { return GetConfigValue<string>(ConfigCode.TimeupLabel); } }
        public List<Int64> ExpLvDef { get { return GetConfigValue<List<Int64>>(ConfigCode.ExpLvDef); } }
        public List<Int64> PalamLvDef { get { return GetConfigValue<List<Int64>>(ConfigCode.PalamLvDef); } }
        public Int64 PbandDef { get { return GetConfigValue<Int64>(ConfigCode.pbandDef); } }

        public string MacroF1 { get { return GetConfigValue<string>(ConfigCode.MacroF1); } }
        public string MacroF2 { get { return GetConfigValue<string>(ConfigCode.MacroF2); } }
        public string MacroF3 { get { return GetConfigValue<string>(ConfigCode.MacroF3); } }
        public string MacroF4 { get { return GetConfigValue<string>(ConfigCode.MacroF4); } }
        public string MacroF5 { get { return GetConfigValue<string>(ConfigCode.MacroF5); } }
        public string MacroF6 { get { return GetConfigValue<string>(ConfigCode.MacroF6); } }
        public string MacroF7 { get { return GetConfigValue<string>(ConfigCode.MacroF7); } }
        public string MacroF8 { get { return GetConfigValue<string>(ConfigCode.MacroF8); } }
        public string MacroF9 { get { return GetConfigValue<string>(ConfigCode.MacroF9); } }
        public string MacroF10 { get { return GetConfigValue<string>(ConfigCode.MacroF10); } }
        public string MacroF11 { get { return GetConfigValue<string>(ConfigCode.MacroF11); } }
        public string MacroF12 { get { return GetConfigValue<string>(ConfigCode.MacroF12); } }
#endregion
		bool updated = false;

		//Dictionary<FontStyle, Font> fontDic = new Dictionary<FontStyle, Font>();
		Dictionary<string, Dictionary<FontStyle, Font>> fontDic = new Dictionary<string, Dictionary<FontStyle, Font>>();
		public Font Font { get { return GetFont(null, FontStyle.Regular); } }

		public Font GetFont(string theFontname, FontStyle style)
		{
			string fn = theFontname;
			if (string.IsNullOrEmpty(theFontname))
				fn = GetConfigValue<string>(ConfigCode.FontName);
			if (!fontDic.ContainsKey(fn))
				fontDic.Add(fn, new Dictionary<FontStyle, Font>());
			Dictionary<FontStyle, Font> fontStyleDic = fontDic[fn];
            if (!fontStyleDic.ContainsKey(style))
            {
                int fontsize = GetConfigValue<int>(ConfigCode.FontSize);
                try
                {
                    fontStyleDic.Add(style, new Font(fn, fontsize, style, GraphicsUnit.Pixel));
                }
                catch
                {
                    fontStyleDic.Add(style, new Font(fn, fontsize, FontStyle.Regular, GraphicsUnit.Pixel));
                }
            }
			return fontStyleDic[style];
		}

		public void ClearFont()
		{
			foreach (KeyValuePair<string, Dictionary<FontStyle, Font>> fontStyleDicPair in fontDic)
			{
				foreach (KeyValuePair<FontStyle, Font> pair in fontStyleDicPair.Value)
				{
					pair.Value.Dispose();
				}
				fontStyleDicPair.Value.Clear();
			}
			fontDic.Clear();
		}
		public List<KeyValuePair<string, string>> GetFiles(string rootdir, string pattern)
		{
			bool toponly = !GetConfigValue<bool>(ConfigCode.SearchSubdirectory);
			bool sort = GetConfigValue<bool>(ConfigCode.SortWithFilename);
			return getFiles(rootdir, rootdir, pattern, toponly, sort);
		}

		private List<KeyValuePair<string, string>> getFiles(string dir, string rootdir, string pattern,bool toponly, bool sort)
		{
			List<KeyValuePair<string, string>> retList = new List<KeyValuePair<string, string>>();
			if (!toponly)
			{
				string[] dirList = Directory.GetDirectories(dir, "*", SearchOption.TopDirectoryOnly);
				if (dirList.Length > 0)
				{
					if (sort)
						Array.Sort(dirList, new StrIgnoreCaseComparer());
					for (int i = 0; i < dirList.Length; i++)
						retList.AddRange(getFiles(dirList[i], rootdir,pattern,toponly, sort));
				}
			}
			string RelativePath = "";
			if (string.Equals(dir, rootdir, StringComparison.CurrentCultureIgnoreCase))
				RelativePath = "";
			else
			{
				if (!dir.StartsWith(rootdir, StringComparison.CurrentCultureIgnoreCase))
					RelativePath = dir;
				else
					RelativePath = dir.Substring(rootdir.Length);
				if (!RelativePath.EndsWith("\\") && !RelativePath.EndsWith("/"))
					RelativePath += "\\";
			}
			string[] erbFiles = Directory.GetFiles(dir, pattern, SearchOption.TopDirectoryOnly);
			if (sort)
				Array.Sort(erbFiles, new StrIgnoreCaseComparer());
			for (int i = 0; i < erbFiles.Length; i++)
                if (Path.GetExtension(erbFiles[i]).ToUpper() == ".ERB" || Path.GetExtension(erbFiles[i]).ToUpper() == ".CSV")
                    retList.Add(new KeyValuePair<string, string>(RelativePath + Path.GetFileName(erbFiles[i]), erbFiles[i]));
			return retList;
		}

		public bool NeedReduceArgumentOnLoad
		{
			get
			{

				ReduceArgumentOnLoadFlag flag = GetConfigValue<ReduceArgumentOnLoadFlag>(ConfigCode.ReduceArgumentOnLoad);
				if (flag == ReduceArgumentOnLoadFlag.ONCE)
					return updated;
				if (flag == ReduceArgumentOnLoadFlag.YES)
					return true;
				//if (flag == ReduceArgumentOnLoadFlag.NO)
				return false;
			}
		}

		private long getUpdateKey()
		{
			string csvDir = Program.ExeDir + "csv\\";
			string erbDir = Program.ExeDir + "erb\\";
			string[] erbFiles = Directory.GetFiles(erbDir, "*.ERB", SearchOption.TopDirectoryOnly);
			string[] csvFiles = Directory.GetFiles(csvDir, "*.csv", SearchOption.TopDirectoryOnly);
			long[] writetimes = new long[erbFiles.Length + csvFiles.Length];
			for (int i = 0; i < erbFiles.Length; i++)
                if (Path.GetExtension(erbFiles[i]).ToUpper() == ".ERB")
                    writetimes[i] = System.IO.File.GetLastWriteTime(erbFiles[i]).ToBinary();
			for (int i = 0; i < csvFiles.Length; i++)
                if (Path.GetExtension(csvFiles[i]).ToUpper() == ".CSV")
                    writetimes[i + erbFiles.Length] = System.IO.File.GetLastWriteTime(csvFiles[i]).ToBinary();
			long key = 0;
			for (int i = 0; i < writetimes.Length; i++)
			{
				unchecked
				{
					key ^= writetimes[i] * 1103515245 + 12345;
				}
			}
			return key;
		}

		private void checkUpdate()
		{
			ReduceArgumentOnLoadFlag flag = GetConfigValue<ReduceArgumentOnLoadFlag>(ConfigCode.ReduceArgumentOnLoad);
			if (flag != ReduceArgumentOnLoadFlag.ONCE)
				return;
			long lastKey = GetConfigValue<long>(ConfigCode.LastKey);
			updated = true;
			long key = getUpdateKey();
			updated = lastKey != key;
			GetItem(ConfigCode.LastKey).SetValue(key);
			if (updated)
				SaveConfig();
		}

		public bool SaveConfig()
		{
			StreamWriter writer = null;

			try
			{
				writer = new StreamWriter(configPath, false, Encode);
				for (int i = 0; i < configArray.Length; i++)
				{
					AConfigItem item = configArray[i];
					if (item == null)
						continue;
					if ((item.Code == ConfigCode.ChangeMasterNameIfDebug) && (item.GetValue<bool>()))
						continue;
					if ((item.Code == ConfigCode.LastKey) && (item.GetValue<long>() == 0))
						continue;
					if (item.Code == ConfigCode.IgnoreWarningFiles)
					{
						List<string> files = item.GetValue<List<string>>();
						foreach (string filename in files)
							writer.WriteLine(item.Text + ":" + filename.ToString());
						continue;
					}
					writer.WriteLine(item.ToString());
				}
			}
			catch (Exception)
			{
				return false;
			}
			finally
			{
				if (writer != null)
					writer.Close();
			}
			return true;
		}

        public bool SaveMacro()
        {
            if (!isMacroChanged)
                return true;
			StreamWriter writer = null;

			try
			{
				writer = new StreamWriter(macroPath, false, Encode);
				for (int i = 0; i < macroArray.Length; i++)
				{
					AConfigItem item = macroArray[i];
					if (item == null)
						continue;
					writer.WriteLine(item.ToString());
				}
			}
			catch (Exception)
			{
				return false;
			}
			finally
			{
				if (writer != null)
					writer.Close();
			}
			return true;
		}        

		public bool LoadConfig()
		{
			ClearFont();
			string defaultConfigPath = Program.ExeDir + "csv\\_default.config";
			string fixedConfigPath = Program.ExeDir + "csv\\_fixed.config";
			if(!File.Exists(defaultConfigPath))
				defaultConfigPath = Program.ExeDir + "csv\\default.config";
			if (!File.Exists(fixedConfigPath))
				fixedConfigPath = Program.ExeDir + "csv\\fixed.config";

			LoadConfig(defaultConfigPath, false);
			LoadConfig(configPath, false);
			LoadConfig(fixedConfigPath, true);
			if (!File.Exists(configPath))
				SaveConfig();
			checkUpdate();
            if (Fontsize < 8)
            {
                MessageBox.Show("tHgTCY܂(8)", "ݒ̃G[");
                AConfigItem fsize = GetConfigItem(ConfigCode.FontSize);
                ((ConfigItem<int>)fsize).Value = 8;
            }
            if (LineHeight < Fontsize)
            {
                MessageBox.Show("s̍tHgTCY菬߁AtHgTCYƓƉ߂܂","ݒ̃G[");
                AConfigItem height = GetConfigItem(ConfigCode.LineHeight);
                ((ConfigItem<int>)height).Value = Fontsize;
            }
            if (SaveDataNos < 20)
            {
                MessageBox.Show("\Z[uf[^Ȃ܂(20)", "ݒ̃G[");
                AConfigItem saves = GetConfigItem(ConfigCode.SaveDataNos);
                ((ConfigItem<int>)saves).Value = 20;
            }
            if (SaveDataNos > 80)
            {
                MessageBox.Show("\Z[uf[^܂(80)", "ݒ̃G[");
                AConfigItem saves = GetConfigItem(ConfigCode.SaveDataNos);
                ((ConfigItem<int>)saves).Value = 80;
            }
            if (MaxLog < 500)
            {
                MessageBox.Show("O\sȂ܂(500)", "ݒ̃G[");
                AConfigItem maxLog = GetConfigItem(ConfigCode.MaxLog);
                ((ConfigItem<int>)maxLog).Value = 500;
            }
            return true;
		}

		public bool LoadConfig(string confPath, bool fix)
		{
			if (!File.Exists(confPath))
				return false;
			EraStreamReader eReader = new EraStreamReader();
			if (!eReader.Open(confPath))
				return false;
			try
			{
				string line = null;
				bool defineIgnoreWarningFiles = false;
				while ((line = eReader.ReadLine()) != null)
				{
					if ((line.Length == 0) || (line[0] == ';'))
						continue;
					string[] tokens = line.Split(new char[] { ':' });
					if (tokens.Length < 2)
						continue;
					AConfigItem item = GetConfigItem(tokens[0].Trim());
					if (item != null)
					{
						if ((item.Code == ConfigCode.IgnoreWarningFiles))
						{ 
							if (!defineIgnoreWarningFiles)
								(item.GetValue<List<string>>()).Clear();
							defineIgnoreWarningFiles = true;
							if ((item.Fixed) && (fix))
								item.Fixed = false;
						}
                        if (item.Code == ConfigCode.TextEditor)
                        {
                            //pX̊֌Wtokens[2]͎gȂƂȂ
                            if (tokens.Length > 2)
                            {
                                if (tokens[2].StartsWith("\\"))
                                    tokens[1] += ":" + tokens[2];
                                if (tokens.Length > 3)
                                {
                                    for (int i = 3; i < tokens.Length; i++)
                                    {
                                        tokens[1] += ":" + tokens[i];
                                    }
                                }
                            }
                        }
                        if (item.Code == ConfigCode.EditorArgument)
                        {
                            //pXy[XvKvȃGfB^̂ŕʏ
                            ((ConfigItem<string>)item).Value = tokens[1];
                            continue;
                        }
						if ((item.TryParse(tokens[1])) && (fix))
							item.Fixed = true;
					}
#if DEBUG
					//else
					//	throw new Exception("RtBOt@C");
#endif
				}
			}
			catch { return false; }
			finally { eReader.Dispose(); }
			return true;
		}

		// 1.52aϕ@iPʂ̍ւёOuAû߂̃RtBOj
		public void LoadReplaceFile(string filename)
		{
			EraStreamReader eReader = new EraStreamReader();
			if (!eReader.Open(filename))
				return;
			try
			{
				string line = null;
				while ((line = eReader.ReadLine()) != null)
				{
					if ((line.Length == 0) || (line[0] == ';'))
						continue;
                    string[] tokens = line.Split(new char[] { ',', ':' });
					if (tokens.Length < 2)
						continue;
                    string itemName = tokens[0].Trim();
                    tokens[1] = line.Substring(tokens[0].Length + 1);
                    if (string.IsNullOrEmpty(tokens[1].Trim()))
                        continue;
                    AConfigItem item = GetReplaceItem(itemName);
					if (item != null)
						item.TryParse(tokens[1]);
				}
			}
			catch { return; }
			finally { eReader.Dispose(); }
		}

        public void LoadMacroFile(string filename)
        {
            EraStreamReader eReader = new EraStreamReader();
            if (!eReader.Open(filename))
                return;
            try
            {
                string line = null;
                while ((line = eReader.ReadLine()) != null)
                {
                    if ((line.Length == 0) || (line[0] == ';'))
                        continue;
                    string[] tokens = line.Split(new char[] { ',', ':' });
                    if (tokens.Length < 2)
                        continue;
                    if (string.IsNullOrEmpty(tokens[1].Trim()))
                        continue;
                    AConfigItem item = GetMacroItem(tokens[0].Trim());
                    if (item != null)
                        item.TryParse(tokens[1]);
                }
            }
            catch { return; }
            finally { eReader.Dispose(); }
        }

        bool isMacroChanged = false;

        public void SetMacro(Keys key, string macro)
        {
            AConfigItem item;
            switch (key)
            {
                case Keys.F1:
                    item = GetMacroItem(ConfigCode.MacroF1);
                    item.TryParse(macro);
                    break;
                case Keys.F2:
                    item = GetMacroItem(ConfigCode.MacroF2);
                    item.TryParse(macro);
                    break;
                case Keys.F3:
                    item = GetMacroItem(ConfigCode.MacroF3);
                    item.TryParse(macro);
                    break;
                case Keys.F4:
                    item = GetMacroItem(ConfigCode.MacroF4);
                    item.TryParse(macro);
                    break;
                case Keys.F5:
                    item = GetMacroItem(ConfigCode.MacroF5);
                    item.TryParse(macro);
                    break;
                case Keys.F6:
                    item = GetMacroItem(ConfigCode.MacroF6);
                    item.TryParse(macro);
                    break;
                case Keys.F7:
                    item = GetMacroItem(ConfigCode.MacroF7);
                    item.TryParse(macro);
                    break;
                case Keys.F8:
                    item = GetMacroItem(ConfigCode.MacroF8);
                    item.TryParse(macro);
                    break;
                case Keys.F9:
                    item = GetMacroItem(ConfigCode.MacroF9);
                    item.TryParse(macro);
                    break;
                case Keys.F10:
                    item = GetMacroItem(ConfigCode.MacroF10);
                    item.TryParse(macro);
                    break;
                case Keys.F11:
                    item = GetMacroItem(ConfigCode.MacroF11);
                    item.TryParse(macro);
                    break;
                case Keys.F12:
                    item = GetMacroItem(ConfigCode.MacroF12);
                    item.TryParse(macro);
                    break;
                default:
                    return;
            }
            isMacroChanged = true;
        }
	}
}